<?php
/**
 * @copyright	Copyright (c) 2019 Hikashop delyva Shipping Plugin. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// no direct access
defined('_JEXEC') or die;

/**
 * hikashopshipping - delyva Plugin
 *
 * @package		Joomla.Plugin
 * @subpakage	Hikashop delyva Shipping Plugin.delyva
 */
class plgHikashopshippingDelyva extends hikashopShippingPlugin {
	var $multiple = true;
	var $name = 'Delyva';
	
	var $pluginConfig = array(
		'config_sender_address' => array('Pick up Address', 'input'),
		'config_sender_postcode' => array('Pick up Postcode', 'input'),
		'item_type' => array('Item Type', 'list', array('DOCUMENT','PARCEL','FOOD','FLOWER','CHILL','FROZEN','CAKE','OTHER','TASK', 'BULKY'))
		);
	
	public function onShippingDisplay(&$order,&$methods,&$usable_methods,&$messages)
	{
		//write file to check output;
		//$myfile = fopen("testing.txt", "w") or die("Unable to open file!");
		//fwrite($myfile,print_r($this,true));
		//fclose($myfile);
		
		$ret = parent::onShippingDisplay($order, $methods, $usable_methods, $messages);
		foreach($methods as $method)
		{
			if($method->shipping_type == "delyva")
			{
				$delyva = $method;
			}
		}
		
		//get response by using curl;
		$data = $this->delyvacurl($order,$delyva);

		//display all delyva's shipping methods;
		foreach($data as $newmethods)
		{			
			$shipping_id = $newmethods->service_code;
			$shipping_name = $newmethods->name;
			$shipping_description = $newmethods->description;
			$shipping_price = $newmethods->price;

			$newmethods->shipping_id = $shipping_id;
			$newmethods->shipping_type = "delyva";
			$newmethods->shipping_zone_namekey = "";
			$newmethods->shipping_tax_id = "0";
			$newmethods->shipping_price = $shipping_price;
			$newmethods->shipping_currency_id = "1";
			$newmethods->shipping_name = $shipping_name;
			$newmethods->shipping_description = $shipping_description;
			$newmethods->shipping_published = "1";
			$newmethods->shipping_ordering = "1";
			$newmethods->shipping_currency = "";
			$newmethods->shipping_params = $delyva->shipping_params;
			$newmethods->shipping_images = "";
			$newmethods->shipping_access = "all";
			
			array_push($usable_methods, $newmethods);
		}

	}
	
	//postparam
	private function delyvacurl($order, $delyva)
	{		
		$sender_address = $delyva->shipping_params->config_sender_address;
		$sender_postcode = $delyva->shipping_params->config_sender_postcode;
		$sender_country = "MY";
		$receiver_address = $order->shipping_address->address_street;
		$receiver_postcode = $order->shipping_address->address_post_code;
		$receiver_country = "MY";
		$item_weight = $order->package["weight"]["value"];
		
		$item_type = $delyva->shipping_params->item_type;
		switch($item_type)
		{
			case 0:
				$item_type = "PARCEL";
				break;
			case 1:
				$item_type = "DOCUMENT";
				break;
			case 2:
				$item_type = "FOOD";
				break;
			case 3:
				$item_type = "FLOWER";
				break;
			case 3:
				$item_type = "CHILL";
				break;
			case 3:
				$item_type = "FROZEN";
				break;
			case 3:
				$item_type = "CAKE";
				break;
			case 3:
				$item_type = "OTHER";
				break;
			case 3:
				$item_type = "TASK";
				break;
			case 9:
				$item_type = "BULKY";
				break;
		}
		
		date_default_timezone_set("Asia/Kuala_Lumpur");
		$date = new JDate('now +9 hour');
		$shipment_date = date_format($date, 'Y-m-d')."T".date_format($date, 'H:i:s').".000Z";
		
		$ch = curl_init();
		
		curl_setopt($ch, CURLOPT_URL, "https://api.matdespatch.com/v2/service/price_quote");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_HEADER, FALSE);

		curl_setopt($ch, CURLOPT_POST, TRUE);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "{
		  \"sender_address\": \"".$sender_address."\",
		  \"sender_postcode\": \"".$sender_postcode."\",
		  \"sender_country\": \"".$sender_country."\",
		  \"receiver_address\": \"".$receiver_address."\",
		  \"receiver_postcode\": \"".$receiver_postcode."\",
		  \"receiver_country\": \"".$receiver_country."\",
		  \"item_weight\": ".$item_weight.",
		  \"item_type\": \"".$item_type."\",
		  \"shipment_date\": \"".$shipment_date."\"
		}");
		
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		  "Content-Type: application/json",
		  "Authorization: Basic NWNhNTUzZTkzYTQ2NTIwNjVlY2NkZGIyOjUzOWQwNjkxZDgwOWUxZjk5NThiNjU4ZWYwYTUwNGJm",
		));

		$response = curl_exec($ch);
		$response = json_decode($response);
		curl_close($ch);
		
		return $response;
	}
	
	
	//do not touch here...
	function shippingMethods(&$main){
		$methods = array();
		if(!empty($main->shipping_params->methodsList)) {
			$main->shipping_params->methods = hikashop_unserialize($main->shipping_params->methodsList);
		}
		if(!empty($main->shipping_params->methods)) {
			foreach($main->shipping_params->methods as $method){
				$selected = null;
				foreach($this->fedex_methods as $fedex) {
					if($fedex['code'] == $method) {
						$selected = $fedex;
						break;
					}
				}
				if($selected)
					$methods[$main->shipping_id . '-' . $selected['key']] = $selected['name'];
			}
		}
		return $methods;
	}		
}
